<template>
  <div>
    <div class="course-list" v-if="myCourses">
      <h3>My Courses</h3>
      <ul>
        <li v-for="course in myCourses.nodes" :key="course.id">
          <nuxt-link :to="`/courses/${course.id}`">
            {{ course.name || "Unnamed Course" }}
          </nuxt-link>
          <nuxt-link :to="`/courses/${course.id}/edit`">[Edit]</nuxt-link>
        </li>
      </ul>
      <nuxt-link to="/courses/create">Create New Course</nuxt-link> |
      <nuxt-link to="/courses/import">Import Course</nuxt-link>
    </div>

    <portal to="map">
      <div v-if="myCourses && myCourses.nodes && myCourses.nodes.length">
        <MglConfig
          :items="
            myCourses.nodes
              .map((c) => c.checkpoints.nodes[0])
              .filter((c) => !!c)
          "
        />
        <div v-for="course in myCourses.nodes" :key="course.id">
          <Course v-if="course.checkpoints.nodes.length" :value="course" />
        </div>
      </div>
    </portal>
  </div>
</template>

<script>
import { mapState } from "vuex";
import LoginWidget from "~/components/LoginWidget";
import { query } from "~/plugins/data-management";
import MglConfig from "~/components/mapping/MglConfig";
import Course from "~/components/mapping/Course";

const FIELDS = `
fragment fields on Course {
     id name public description writeable printConfig
     startCheckpoint {
      lat lng
    }
    checkpoints(first:1) {
      nodes {
        lat lng
      }
    }
}      `;

const QUERY =
  `query {
  myCourses:courses(first: 100,condition: {writeable:true}) {
    
    nodes {
      ...fields
    }
  }
}` + FIELDS;

export default {
  layout: "default",
  asyncData: query(QUERY),
  computed: mapState({
    loggedOut: (state) => !(state.user && state.user.id),
    user: (state) => state.user,
  }),
  components: {
    LoginWidget,
    MglConfig,
    Course,
  },
  filters: {
    coordinates(value) {
      return value && [value.lng, value.lat];
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~assets/mixins";
/*
.hero-bg {
  background:  url("https://static.wixstatic.com/media/add43d_09a0a4735bb549dbb2bd3fb1cb8808ed~mv2.png") no-repeat center;
  background-size: contain;
}
*/
.dark-bg {
  background: $color-background;
  padding: $grid * 2;
  border-radius: $grid;
  pointer-events: initial;
}

.course-list {
  pointer-events: initial;
  background: $color-background;
  width: $grid * 20;
}

.fixed-full {
  pointer-events: none;
}

.ui-column,
h1 {
  text-align: center;
}

h1 {
  color: $color-brand-primary;
  text-transform: uppercase;
  font-weight: 800;
}

.buttons {
  height: $grid * 1.5;
}

.button {
  margin: 0 $grid * 0.5;
}
</style>
